/*
 * http client example
 * (C) 2004 Sam Steele
 *
 * Email: sam.steele@gmail.com
 * Web:   http://www.c99.org/
 *
 * This source is covered by the terms of the new BSD license. For more info
 * please read the LICENSE file
 *
 */

#include <kos.h>
#include <lwip/lwip.h>

/* This is called by the http module to give us feedback during the transfer
 * process.  In a real application, this would update some sort of status
 * bar or something. */
void callback(char *msg) {
  static int y=24;
  int z=0,x=0;
  for(z=0;z<strlen(msg);z++) {
    if(msg[z]=='\r' || msg[z]=='\n') {
      y+=24; x=0;
      continue;
    }
    bfont_draw(vram_s + y*640+x, 640, 0, msg[z]);
    x+=16;
    if(x>640) { y+=24; x=0; }
  }
  y+=24;
  if(y>460) y=24;
}

void main() {
  int fd;
  char *buf;
  char type[100]; /* the content-type of the file we recieve */
  int len; /* the length of the file we recieve */

  net_init(); /* initialize the network devices (BBA, LAN) */

/* initialize lwip using netcfg 
This will grab your configuration from a VMU, Flash, 
the current directory, or a cd.
*/
  lwip_kos_init(); 

  set_status_callback(callback); /* set the function used for feedback */

  /* retrieve: http://www.c99.org/dzztnet/index.php */

  http_get_file("/ram/online.tmp","www.c99.org",80,"/dzztnet/index.php",type,&len);
  
  if(len==0) {
    printf("Error retrieving file\n");
  } else { 
    /* open the file we downloaded */
    buf=malloc(len+1);
    fd=fs_open("/ram/online.tmp",O_RDONLY);
    fs_read(fd,buf,len);
    buf[len]='\0';
    fs_close(fd);

    printf("MIME type: %s\n",type);
    printf("File contents: %s\n",buf);

    /* display the MIME type on the screen */
    callback(type);

    /* display contents on the screen */
    callback(buf);
  }
  thd_sleep(10000);
}
